﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.Editors;
using System.Collections;
using System.ComponentModel;
using XamMultiComboEditor;
using Infragistics.Windows.DataPresenter;

namespace MultiComboInDataGrid
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

        }

        private void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            TestCaseAttributeCategory attributeCategory = new TestCaseAttributeCategory();
            attributeCategory.AllValues = new ObservableCollection<TestCaseAttributeValue>
            {
                new TestCaseAttributeValue { Id = 1, Value = "Item 1" },
                new TestCaseAttributeValue { Id = 2, Value = "Item 2" },
                new TestCaseAttributeValue { Id = 3, Value = "Item 3" },
                new TestCaseAttributeValue { Id = 4, Value = "Item 4" },
                new TestCaseAttributeValue { Id = 5, Value = "Item 5" },
            };
           

            var xamComboEditorStyle = new Style(typeof(XamMultiSelectionComboEditor));
            xamComboEditorStyle.Setters.Add(new Setter(XamMultiSelectionComboEditor.ItemSourceProperty, attributeCategory.AllValues));
            xamComboEditorStyle.Setters.Add(new Setter(XamMultiSelectionComboEditor.DisplayMemberPathProperty, "Value"));
            xamComboEditorStyle.Setters.Add(new Setter(XamMultiSelectionComboEditor.SelectedValuePathProperty,  null));

            UnboundField field = new UnboundField();
            field.Name = "Invoices";
            field.BindingPath = new PropertyPath("Invoices");
            field.DataType = typeof(ObservableCollection<TestCaseAttributeValue>);
            field.IsExpandable = false;             
            field.Settings.EditorStyle = xamComboEditorStyle;
            field.Settings.EditorType = typeof(XamMultiSelectionComboEditor);
            field.Tag = attributeCategory;


            xamComboEditorStyle = new Style(typeof(XamMultiSelectionComboEditor));
            xamComboEditorStyle.Setters.Add(new Setter(XamMultiSelectionComboEditor.ItemSourceProperty, attributeCategory.AllValues));
            xamComboEditorStyle.Setters.Add(new Setter(XamMultiSelectionComboEditor.DisplayMemberPathProperty, "Value"));
            xamComboEditorStyle.Setters.Add(new Setter(XamMultiSelectionComboEditor.SelectedValuePathProperty, "Value"));
            UnboundField field1 = new UnboundField();
            field1.Name = "Strs";
            field1.BindingPath = new PropertyPath("Strings");
            field1.DataType = typeof(ObservableCollection<string>);
            field1.IsExpandable = false; 
            field1.Settings.EditorStyle = xamComboEditorStyle;
            field1.Settings.EditorType = typeof(XamMultiSelectionComboEditor);
            field1.Tag = attributeCategory;

            xamComboEditorStyle = new Style(typeof(XamMultiSelectionComboEditor));
            xamComboEditorStyle.Setters.Add(new Setter(XamMultiSelectionComboEditor.ItemSourceProperty, attributeCategory.AllValues));
            xamComboEditorStyle.Setters.Add(new Setter(XamMultiSelectionComboEditor.DisplayMemberPathProperty, "Value"));
            xamComboEditorStyle.Setters.Add(new Setter(XamMultiSelectionComboEditor.SelectedValuePathProperty, "Id"));
            UnboundField field2 = new UnboundField();
            field2.Name = "Nums";
            field2.BindingPath = new PropertyPath("Nums");
            field2.DataType = typeof(ObservableCollection<int>);
            field2.IsExpandable = false;

            xamComboEditorStyle.Setters.Add(new Setter(XamMultiSelectionComboEditor.SelectedValuePathProperty, "Id"));
            field2.Settings.EditorStyle = xamComboEditorStyle;
            field2.Settings.EditorType = typeof(XamMultiSelectionComboEditor);
            field2.Tag = attributeCategory;

            e.FieldLayout.Fields.Add(field);
            e.FieldLayout.Fields.Add(field1);
            e.FieldLayout.Fields.Add(field2);

            
        }


    }

        [Serializable]
    public class TestCaseAttributeCategory
    {


        public int Id { get; set; }


        public string CategoryName { get; set; }


        public ObservableCollection<TestCaseAttributeValue> AllValues { get; set; }


    }

        [Serializable]
    public class TestCaseAttributeValue
    {

        public int Id { get; set; }

        public string Value { get; set; }


        public string CategoryName { get; set; }


    }



    #region Data


    public class VM
    {
        public VM()
        {
            Random r = new Random();
            

            Data = new ObservableCollection<Data>();

            for (int i = 0; i < 10; i++)
            {
                Data.Add(new Data
                {
                    ID = i,
                    Name = "Item " + i,
                    //Invoices = new ObservableCollection<TestCaseAttributeValue>(),
                    //Strings = new ObservableCollection<string>(),
                    //Nums = new ObservableCollection<double>(),
                });
            }
        }

        public ObservableCollection<Data> Data { get; set; } 
    }



    public class Data : PropertyChangedNotifier
    {
        private ObservableCollection<TestCaseAttributeValue> invoices;
        public int ID { get; set; }
        public string Name { get; set; }
        public string Invoice { get; set; }

        public ObservableCollection<TestCaseAttributeValue> Invoices
        {
            get
            {
                return invoices;
            }
            set
            {
                invoices = value; OnPropertyChagned("Invoices");
            }
        }

        private ObservableCollection<string> strings;
        public ObservableCollection<string> Strings
        {
            get { return strings; }
            set { strings = value; OnPropertyChagned("Strings"); }
        }

        private ObservableCollection<double> nums;
        public ObservableCollection<double> Nums
        {
            get { return nums; }
            set { nums = value; OnPropertyChagned("Nums"); }
        }
    }

    [Serializable]
    public class Invoice
    {
        public string InvoiceCode { get; set; }
        public string Description { get; set; }
        public decimal Price { get; set; }

        public override bool Equals(object obj)
        {
            if (!(obj is Invoice))
                return false;
            return InvoiceCode == (obj as Invoice).InvoiceCode;
        }
    }


    public class PropertyChangedNotifier : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChagned(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    #endregion
}
